import os
import signal
import subprocess

fp_current = os.path.abspath(os.path.dirname(__file__))
fp_pid = fp_current + '/pid.txt'
fp_script = fp_current + '/mod_pywebsocket/standalone.py'
cmd = ['python', fp_script, '-p', '8180']

def start_server(fp_pid):
    # check the server is running
    if os.path.exists(fp_pid):
        stop_server(fp_pid)

    # start server
    process = subprocess.Popen(cmd)

    # create pid file
    with open(fp_pid, 'w') as pid_file:
        pid_file.write(str(process.pid))
    return True

def stop_server(fp_pid):
    # check server if is running
    if not os.path.exists(fp_pid):
        return

    # try to terminate/stop server's process
    with open(fp_pid) as pid_file:
        pid = int(pid_file.read())
        try:
            os.kill(pid, signal.SIGTERM)
        except OSError:
            pass #ignore errors if process does not exist

    # remove pid file
    os.unlink(fp_pid)

if __name__ == '__main__':
    start_server(fp_pid)
