# coding: utf-8

# 本モジュールを使う xxx_wsh.py スクリプトがあれば、サーバ起動時にこれをコンパイルする
# wsgiref では psycopg2 インポート時にパス設定必要だったが、今回は不要（楽！）

import cgi
import codecs
import datetime
import psycopg2
import psycopg2.extensions
import select
import usr_cancel
import usr_xhtml

def main(req, line):
    if usr_cancel.exec1(line):
        ws_send(req, '中止指示を受信')
        return
    query(req, line)

def query(req, line):
    dic = cgi.parse_qs(line.encode('utf-8'))
    try:
        con = dic['con'][0]
        sql = dic['sql'][0]
    except:
        ws_send(req, 'input for connection or query.')
        return

    aconn = conn_open(req, con)
    if aconn is None:
        return
    ckey = usr_cancel.start()
    ws_send(req, 'cancelkey=' + ckey, 0)

    try:
        acurs = aconn.cursor()
        acurs.execute(sql)
        ws_send(req, 'query started')
        wait(req, acurs.connection, ckey)
        
    except psycopg2.Error as e:
        if e.pgerror is None:
            return
        err = e.pgerror.replace('<', '&lt;')
        err = err.replace(' ', '&nbsp;')
        err = err.rstrip('\n').replace('\n', '<br />')
        ws_send(req, err, 0)
        conn_close(req, aconn)
        return

    ws_send(req, 'query ended')
    usr_cancel.end(ckey)
    try:
        col = acurs.description
        dat = acurs.fetchall()
    except:
        col = []
        dat = []

    acurs.close()
    conn_close(req, aconn)

    if len(col) == 0:
        ws_send(req, 'クエリの結果出力はありません')
    else:
        ws_send(req, usr_xhtml.output(col, dat), 0)

def conn_open(req, con):
    try:
        aconn = psycopg2.connect(con, async=1)
        wait(req, aconn)
    except :
        ws_send(req, 'unable to connect to the database.')
        return

    ws_send(req, 'connected')
    return aconn

def conn_close(req, conn):
    conn.close()
    ws_send(req, 'disconnected')

def wait(req, conn, ckey=None):
    note_pre = [0]
    while True:
        if ckey is not None and usr_cancel.exec2(ckey):
            conn.cancel()
            ws_send(req, '中止しました。ロールバックします')
            conn.rollback()
        state = conn.poll()
        send_notices(req, conn, note_pre)
        if state == psycopg2.extensions.POLL_OK:
            break
        elif state == psycopg2.extensions.POLL_WRITE:
            select.select([], [conn.fileno()], [])
        elif state == psycopg2.extensions.POLL_READ:
            select.select([conn.fileno()], [], [])
        else:
            raise psycopg2.OperationalError("poll() returned %s" % state)

def send_notices(req, conn, note_pre):
    note = conn.notices
    if len(note) == note_pre[0]: # 新規メッセージなければ終了
        return
    ws_send(req, note[-1]) #  新規メッセージだけ送信
    note_pre[0] += 1

def ws_send(req, mes, addtime = 1):
    if addtime:
        mes = datetime.datetime.now().strftime('%H:%M:%S') + ' ' + mes
    req.ws_stream.send_message(mes.decode('utf-8'))

"""
if __name__ == '__main__':
    ここは常に実行されない
    print 'main'
"""
